/*	
					+---------------------------+
					|		jBasic Library		|
					|			 ---			|
					|		By: Nathaniel		|
					|		   "Eeems"			|
					|		 van Diepen			|
					|			 ---			|
					|			©2010			|
					+---------------------------+
	How to use:
		This Library adds addition commands to the standard JavaScript set.
		This is aimed at creating Javascript games, and helps people
		transition from TI-BASIC to JavaScript. 
*/
/*
	initail variables and settings
									*/
 var d = new Date();
//---framerate stuff---\\
fps_update = 1;
fps_fps = 0;
fps_last = d.getTime();
fps_frame = 0;
log_length = 10;
pix = "px"; 					//cut down on size
var key_down = [];
document.onkeydown = keydown;
document.onkeyup = keyup;
//checks to see if the screen is displayed
function isOn(){
 ans = gScreen.style.visibility;
 if (ans != "visible"){
  return false;
 }
 return true;
}
//displays the screen area
function dispScrn(w,h,x,y){
 gScreen = document.createElement('div');
 document.id = "gScreen";
 gScreen.style.width = w+pix;
 gScreen.style.height = h+pix;
 gScreen.style.position = "absolute";
 gScreen.style.left = x+pix;
 gScreen.style.top = y+pix;
 gScreen.style.backgroundColor = "#ACAC83";
 gScreen.style.borderStyle = "groove";
 isScreen = true;
 return document.body.appendChild(gScreen);
}
//displays text on the screen area
function text(x,y,size,text){
 textNode = document.createElement('div');
 textNode.style.left = x+pix;
 textNode.style.top = y+pix;
 textNode.style.fontSize = size+pix;
 textNode.style.position = "absolute";
 textNode.innerHTML = text;
 ans = gScreen.appendChild(textNode);
 return ans;
}
//creates a black box and displays it
function pixelOn(x,y,color,w,h){
 pxl = document.createElement('div');
 pxl.style.position = "absolute";
 pxl.style.left = x+pix;
 pxl.style.top = y+pix;
 pxl.style.backgroundColor = color;
 pxl.style.width = w+pix;
 pxl.style.height = h+pix;
 ans = gScreen.appendChild(pxl);
 return ans;
}
//displays an image
function sprite(x,y,w,h,src){
 img = document.createElement('img');
 img.style.position = "absolute";
 img.style.left = x+pix;
 img.style.top = y+pix;
 img.src = src;
 img.style.width = w+pix;
 img.style.height = h+pix;
 ans = gScreen.appendChild(img);
 return ans;
}
//draws a line
function Line(Ax,Ay,Bx,By,w,color){
 var lineLength = Math.sqrt( (Ax-Bx)*(Ax-Bx)+(Ay-By)*(Ay-By) );
 line = document.createElement('div');
 for( var i=0; i<lineLength; i=i+w){
  div = document.createElement('div');
  div.style.position = "absolute";
  div.style.left = Math.round( Ax+(Bx-Ax)*i/lineLength )+pix;
  div.style.top = Math.round( Ay+(By-Ay)*i/lineLength  )+pix;
  div.style.backgroundColor = color;
  div.style.width = w+pix;
  div.style.height = w+pix;
  line.appendChild(div);
 }
 ans = gScreen.appendChild(line);
 return ans;
}
//clears the screenarea
function clrGraph(){
  while(gScreen.hasChildNodes()){
   gScreen.removeChild(gScreen.lastChild);
  }
}
//returns a random integer between a and b
function randomInt(a,b) {
 if (a < 0) {
  b = (b*2)+1;
 }
 return (Math.floor(Math.random()*b)+a)
}
//randomly returns true or false
function rand(){
 if (randomInt(0,1) == 1){
  return true;
 } else {
  return false;
 }
}
//deletes the object called by the pointer
function pixelOff(pointer){
 while(pointer.hasChildNodes()){
  pointer.removeChild(pointer.lastChild);
 }
 gScreen.removeChild(pointer);
}
//makes the screen invisible
function screenOff(){
 gScreen.style.visibility = "hidden";
}
//makes the screen visible
function screenOn(){
 gScreen.style.visibility = "visible";
}
//draws a circle (must have CSS% support)
function circle(x,y,radius,color){
 div = document.createElement('div');
 div.style.position = "absolute";
 div.style.left = x+pix;
 div.style.top = y+pix;
 width = radius*2+pix;
 div.style.width = width;
 div.style.height = width;
 div.style.MozBorderRadius = radius+pix;
 div.style.WebkitBorderRadius = radius+pix;
 div.style.IwebkitBorderRadius = radius+pix;
 div.style.borderRadius = radius+pix;
 div.style.backgroundColor = color;
 ans = gScreen.appendChild(div);
 return ans;
}
//draws an object
function object(type,css,html,x,y){
 obj = document.createElement(type);
 obj.setAttribute('style',css);
 obj.style.position = "absolute";
 obj.style.left = x+pix;
 obj.style.top = y+pix;
 obj.innerHTML = html;
 ans = gScreen.appendChild(obj);
 return ans;
}  
//recalls and/or sets the x location of the object
function objLocX(obj,value) {
 if (value){
  obj.style.left = value;
 }
 return parseFloat(obj.style.left);
}
//recalls and/or sets the y location of the object
function objLocY(obj,value) {
 if (value){
  obj.style.top = value;
 }
 return parseFloat(obj.style.top);
}
//returns the x location of the right side of the object
function objLocWidth(obj) {
 return objLocX(obj)+parseFloat(obj.style.width);
}
//returns the y location of the bottom of the object
function objLocHeight(obj) {
 return objLocY(obj)+parseFloat(obj.style.height);
}
//returns true if key is down
function getKey(e){
 var contains = false;
 for (var i = 0; i < key_down.length; i++){
  if (key_down[i] == e){
   contains = true;
   break;
  }
 }
 return contains;
}
//simulate a keypress
function keySim(key,time){
 e.keyCode = key;
 keydown(e);
 setTimeout("keyup("+e+");",time);
}
//checks to see if the object is within the window
function objCheck(obj){
 ans = false;
 if (objLocHeight(obj)<=parseFloat(gScreen.style.height) && objLocWidth(obj)<=parseFloat(gScreen.style.width) && 0<=objLocY(obj) && 0<=objLocX(obj)){
  ans = true;
 }
 return ans;
}
//checks to see if obj is on obj2
function collision(obj,obj2,a,b,c,d){
 //first objects location
 if (a){
  x1 = objLocX(obj)+a;
 }else{
  x1 = objLocX(obj);
 }
 if(c){
  x2 = objLocWidth(obj)+c;
 }else{
  x2 = objLocWidth(obj);
 }
 if (b){
  y1 = objLocY(obj)+b;
 }else{
  y1 = objLocY(obj);
 }
 if (d){
  y2 = objLocHeight(obj)+d;
 }else{
  y2 = objLocHeight(obj);
 }
 //second objects locations
 ox1 = objLocX(obj2);
 ox2 = objLocWidth(obj2);
 oy1 = objLocY(obj2);
 oy2 = objLocHeight(obj2);
 //test
 if((x2-x1)*(y2-y1) < (ox2-ox1)*(oy2-oy1)){
  if (((x1>ox1 && x1<ox2)||(x2>ox1 && x2<ox2))&&((y1>oy1 && y1<oy2)||(y2>oy1 && y2<oy2))){
   return true;
  }
 }else{
  if (((ox1>x1 && ox1<x2)||(ox2>x1 && ox2<x2))&&((oy1>y1 && oy1<y2)||(oy2>y1 && oy2<y2))){
   return true;
  }
 }
 return false;
}
//checks if an object is at a specific location
function pixelTest(obj,x1,y1,x2,y2){
//object location
 ox1 = objLocX(obj);
 ox2 = objLocWidth(obj);
 oy1 = objLocY(obj);
 oy2 = objLocHeight(obj);
 //test
 if((x2-x1)*(y2-y1) < (ox2-ox1)*(oy2-oy1)){
  if (((x1>ox1 && x1<ox2)||(x2>ox1 && x2<ox2))&&((y1>oy1 && y1<oy2)||(y2>oy1 && y2<oy2))){
   return true;
  }
 }else{
  if (((ox1>x1 && ox1<x2)||(ox2>x1 && ox2<x2))&&((oy1>y1 && oy1<y2)||(oy2>y1 && oy2<y2))){
   return true;
  }
 }
 return false;
}
//returns a random color
function randomColor(format){
 var rint = Math.round(0xffffff * Math.random());
 switch(format){
  case 'hex':
   return ('#0' + rint.toString(16)).replace(/^#0([0-9a-f]{6})$/i, '#$1');
   break;
  case 'rgb':
   return 'rgb(' + (rint >> 16) + ',' + (rint >> 8 & 255) + ',' + (rint & 255) + ')';
   break;
  default:
   return rint;
   break;
 }
}
/*
	start system functions
							*/
//stores the current key that has been pressed into the stack
function keydown(e){
 var contains = false;
 for (var i = 0; i < key_down.length; i++){
  if (key_down[i] == e.keyCode){
   contains = true;
   break;
  }
 }
 if (!contains){
  key_down.push(e.keyCode);
 }
}
//clears the current key that has been released from the stack
function keyup(e){
 var i = key_down.indexOf(e.keyCode);
 if (i != -1){
  key_down.splice(i, 1);
 }
}
/*
	end system functions
							*/
/*
		Debbugging functions
							*/
//setup a debug console
function debug_dispConsole(x,y,w,h,loglen){
 obj = document.createElement('textarea');
 obj.innerHTML = "debugger started";
 obj.style.position = "absolute";
 obj.style.top = y+pix;
 obj.style.left = x+pix;
 obj.style.width = w+pix;
 obj.style.height = h+pix;
 obj.style.backgroundColor = "black";
 obj.style.color = "white";
 obj.id = "debug";
 obj.disabled = "disabled";
 if (loglen){ 
  log_length = loglen;
 }
 return document.body.appendChild(obj);
}
//writes a statement to the debug console
function debug_log_var(inVar,variable_name){
 debug = document.getElementById('debug');
 text = debug.innerHTML;
 debug.innerHTML='variable: '+variable_name+'  value: '+inVar+"\n"+text;
 debug_log_check();
}
//send a message to the debug console
function debug_log_message(message){
 debug = document.getElementById('debug');
 text = debug.innerHTML;
 debug.innerHTML = message+"\n"+text;
 debug_log_check();
}
//send an error message to the debug console
function debug_log_error(message,error_code){
 debug = document.getElementById('debug');
 text = debug.innerHTML;
 if (error_code){
  message = message+' error code: '+error_code;
 }
 debug.innerHTML = '#Error# '+message+"\n"+text;
 debug_log_check();
}
//checks the log to make sure it only has the amount of lines defined by log_length
function debug_log_check(){
 debug = document.getElementById('debug');
 text = debug.innerHTML.replace(/\s+$/g,"")  
 split = text.split("\n")  
 if (split.length > log_length){
  x = 0;
  for (i=0;i<=log_length;i++){
   x = text.indexOf("\n",x+1);
  }
  debug.innerHTML = text.slice(0,x);
 }  
}
//set up a framerate log
//you must put a debug_framerate(); at the end of your main loop for it to calculate
function debug_log_framerate_watch(interval,x,y,frame_interval){
 obj = document.createElement('input');
 obj.type = "text";
 obj.value = 'fps: '+fps_fps;
 obj.style.backgroundColor = "black";
 obj.style.position = "absolute";
 obj.style.color = "white";
 obj.style.width = 100+pix;
 obj.style.left = x+pix;
 obj.style.top = y+pix;
 obj.id = "fps_counter";
 document.body.appendChild(obj);
 fps_update = frame_interval;
 setInterval("debug_framerate_log();",interval);
}
//write to the framerate counter
function debug_framerate_log(){
 obj = document.getElementById('fps_counter');
 obj.value = 'fps: '+Math.round(fps_fps);
}
//calculate the framerate
function debug_framerate(){
 fps_frame++;
 var d = new Date();
 fps_current = d.getTime();
 if (fps_current-fps_last > fps_update){
  fps_fps = fps_frame/((fps_current-fps_last)/100);
  fps_frame = 0;
 }
 fps_last = fps_current;
}
//clears the debug console
function debug_log_clear(){
 document.getElementById('debug').innerHTML = '#log Cleared#';
}
